using GLib;
using dbuster;

const string launcher_dir = "/usr/lib/dbuster";

void main(string[] args){
	
	//Determine name of called application
	string[] splt = args[0].split("/");
	string name = splt[splt.length - 1];

	string[] pass_args = new string[0];
	if (args.length > 1)
		pass_args = args[1 : args.length];


	//Try sending launch command to server
	var client = new external_client();

	if (client.launch_request(name, pass_args))
		return;

	//Manual launch if request cannot be sent
	stdout.printf("dbuster-launch: Launch request failed, proceed with manual launch\n");
	
	//Try to find binary
	string? ret = find_binary(name, launcher_dir);
	if (ret == null){
		stdout.printf(@"dbuster-launch: Binary of '$name' not found!\n");
		return;
	}

	//Build execute string (leave out first argument)
	string argstring = ret;
	for(int q = 1; q < args.length; q++)
		argstring += " " + args[q];

	stdout.printf(@"dbuster-launch: Execute '$argstring'\n");
	Process.spawn_command_line_sync(argstring);
}


